#include <bits/stdc++.h>
using namespace std;

#define rep(i, a, b) for (int i= a; i < (b); ++i)
#define all(x) begin(x), end(x)
#define sz(x) (x).size()
#define int ll
#define F first
#define S second
#define PB push_back
#define MP make_pair
typedef long long int;
typedef pair<int, int> pii;
typedef vector<int> vi;
#define endl '\n'
#define inf 3000000000000000000
#define random rand()^(rand()<<15)
mt19937 rnd(time(nullptr));

namespace std
{
    template<> struct hash<pii>
    {
        size_t operator()(pii const& s) const noexcept
        {
            return ((size_t)s.F) + ((size_t)s.S) * 970592641;
        }
    };
}

unordered_map<pii, vector<pii>> nodes;
unordered_map<pii, ll> groups;

bool mark_groups(pii node, pii parent, ll id) {
    if (groups.find(node) != groups.end())
        return true;

    groups[node] = id;

    for (pii nei : nodes[node]) {
        if (nei == parent)
            continue;

        if (mark_groups(nei, node, id))
            return true;
    }

    return false;
}

array<pii, 4> deltas = {{
    {0, 1},
    {1, 0},
    {0, -1},
    {-1, 0}
}};

bool exists(pii a, pii b) {
    auto res = nodes.find(a);

    if (res == nodes.end())
        return false;

    for (pii nei : res->S) {
        if (nei == b)
            return true;
    }

    return false;
}

ll solve() {
    ll next_id = 0;

    for (auto pair : nodes) {
        pii node = pair.F;

        if (groups.find(node) != groups.end())
            continue;

        if (mark_groups(node, node, next_id++))
            return 0;
    }

    std::vector<pii> conn;

    for (auto pair : nodes) {
        pii a = pair.F;

        for (pii delta : deltas) {
            pii b = {a.F + delta.F, a.S + delta.S};

            if (a < b)
                continue;

            if (exists(a, b))
                continue;

            if (nodes.find(b) == nodes.end())
                continue;

            ll ga = groups[a];
            ll gb = groups[b];

            if (ga > gb)
                swap(ga, gb);

            if (ga == gb)
                return 1;

            conn.push_back({ga, gb});
        }
    }

    unordered_set<pii> found;

    for (pii c : conn) {
        if (found.find(c) != found.end())
            return 2;
        
        found.insert(c);
    }

    for (auto pair : nodes) {
        pii a = pair.F;

        for (pii d1 : deltas) {
            pii b = {a.F + d1.F, a.S + d1.S};

            if (exists(a, b))
                continue;

            for (pii d2 : deltas) {
                pii c = {b.F + d2.F, b.S + d2.S};

                if (a == c)
                    continue;

                if (nodes.find(c) == nodes.end())
                    continue;

                if (exists(b, c))
                    continue;

                if (groups[a] == groups[c])
                    return 2;
            }
        }
    }

    return 3;
}

signed main() {
    cin.tie(0)->sync_with_stdio(0);

    ll edge_count;
    cin >> edge_count;

    for (ll i = 0; i < edge_count; i++) {
        pii a;
        pii b;
        cin >> a.F >> a.S >> b.F >> b.S;

        nodes[a].push_back(b);
        nodes[b].push_back(a);
    }

    cout << solve() << endl;

    return 0;
}
